/* Include files */

#include "blascompat32.h"
#include "PI_plus_PI_sfun.h"
#include "c2_PI_plus_PI.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "PI_plus_PI_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char *c2_debug_family_names[10] = { "nargin", "nargout", "yCurrent",
  "rCurrent", "Kc", "tauI", "deltat", "uCurrent", "uPast", "yPast" };

/* Function Declarations */
static void initialize_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance);
static void initialize_params_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance);
static void enable_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance);
static void disable_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *
  chartInstance);
static void set_sim_state_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c2_st);
static void finalize_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance);
static void sf_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshall(void *chartInstanceVoid, void *c2_u);
static const mxArray *c2_b_sf_marshall(void *chartInstanceVoid, void *c2_u);
static const mxArray *c2_c_sf_marshall(void *chartInstanceVoid, void *c2_u);
static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[19]);
static const mxArray *c2_d_sf_marshall(void *chartInstanceVoid, void *c2_u);
static real_T c2_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c2_uCurrent, const char_T *c2_name);
static real_T c2_b_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c2_b_uPast, const char_T *c2_name);
static real_T c2_c_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c2_b_yPast, const char_T *c2_name);
static uint8_T c2_d_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c2_b_is_active_c2_PI_plus_PI, const char_T
  *c2_name);
static void init_dsm_address_info(SFc2_PI_plus_PIInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_uPast_not_empty = FALSE;
  chartInstance->c2_yPast_not_empty = FALSE;
  chartInstance->c2_is_active_c2_PI_plus_PI = 0U;
}

static void initialize_params_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance)
{
}

static void enable_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *
  chartInstance)
{
  const mxArray *c2_st = NULL;
  const mxArray *c2_y = NULL;
  real_T c2_hoistedGlobal;
  real_T c2_u;
  const mxArray *c2_b_y = NULL;
  real_T c2_b_hoistedGlobal;
  real_T c2_b_u;
  const mxArray *c2_c_y = NULL;
  real_T c2_c_hoistedGlobal;
  real_T c2_c_u;
  const mxArray *c2_d_y = NULL;
  uint8_T c2_d_hoistedGlobal;
  uint8_T c2_d_u;
  const mxArray *c2_e_y = NULL;
  real_T *c2_uCurrent;
  c2_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(4));
  c2_hoistedGlobal = *c2_uCurrent;
  c2_u = c2_hoistedGlobal;
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c2_y, 0, c2_b_y);
  c2_b_hoistedGlobal = chartInstance->c2_uPast;
  c2_b_u = c2_b_hoistedGlobal;
  c2_c_y = NULL;
  if (!chartInstance->c2_uPast_not_empty) {
    sf_mex_assign(&c2_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c2_c_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_setcell(c2_y, 1, c2_c_y);
  c2_c_hoistedGlobal = chartInstance->c2_yPast;
  c2_c_u = c2_c_hoistedGlobal;
  c2_d_y = NULL;
  if (!chartInstance->c2_yPast_not_empty) {
    sf_mex_assign(&c2_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c2_d_y, sf_mex_create("y", &c2_c_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_setcell(c2_y, 2, c2_d_y);
  c2_d_hoistedGlobal = chartInstance->c2_is_active_c2_PI_plus_PI;
  c2_d_u = c2_d_hoistedGlobal;
  c2_e_y = NULL;
  sf_mex_assign(&c2_e_y, sf_mex_create("y", &c2_d_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c2_y, 3, c2_e_y);
  sf_mex_assign(&c2_st, c2_y);
  return c2_st;
}

static void set_sim_state_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c2_st)
{
  const mxArray *c2_u;
  real_T *c2_uCurrent;
  c2_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  *c2_uCurrent = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c2_u, 0)), "uCurrent");
  chartInstance->c2_uPast = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c2_u, 1)), "uPast");
  chartInstance->c2_yPast = c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c2_u, 2)), "yPast");
  chartInstance->c2_is_active_c2_PI_plus_PI = c2_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 3)),
     "is_active_c2_PI_plus_PI");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_PI_plus_PI(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance)
{
}

static void sf_c2_PI_plus_PI(SFc2_PI_plus_PIInstanceStruct *chartInstance)
{
  int32_T c2_previousEvent;
  real_T c2_hoistedGlobal;
  real_T c2_b_hoistedGlobal;
  real_T c2_c_hoistedGlobal;
  real_T c2_d_hoistedGlobal;
  real_T c2_e_hoistedGlobal;
  real_T c2_yCurrent;
  real_T c2_rCurrent;
  real_T c2_Kc;
  real_T c2_tauI;
  real_T c2_deltat;
  uint32_T c2_debug_family_var_map[10];
  real_T c2_nargin = 5.0;
  real_T c2_nargout = 1.0;
  real_T c2_uCurrent;
  real_T c2_f_hoistedGlobal;
  real_T c2_g_hoistedGlobal;
  real_T c2_a;
  real_T c2_b;
  real_T c2_y;
  real_T c2_b_a;
  real_T c2_b_b;
  real_T c2_b_y;
  real_T c2_A;
  real_T c2_B;
  real_T c2_x;
  real_T c2_c_y;
  real_T c2_b_x;
  real_T c2_d_y;
  real_T c2_c_x;
  real_T c2_e_y;
  real_T c2_f_y;
  real_T c2_c_a;
  real_T c2_c_b;
  real_T c2_g_y;
  real_T *c2_b_yCurrent;
  real_T *c2_b_uCurrent;
  real_T *c2_b_rCurrent;
  real_T *c2_b_Kc;
  real_T *c2_b_tauI;
  real_T *c2_b_deltat;
  c2_b_deltat = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c2_b_tauI = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c2_b_Kc = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c2_b_rCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c2_b_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_b_yCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,1);
  _SFD_DATA_RANGE_CHECK(*c2_b_yCurrent, 0U);
  _SFD_DATA_RANGE_CHECK(*c2_b_uCurrent, 1U);
  _SFD_DATA_RANGE_CHECK(*c2_b_rCurrent, 2U);
  _SFD_DATA_RANGE_CHECK(*c2_b_Kc, 3U);
  _SFD_DATA_RANGE_CHECK(*c2_b_tauI, 4U);
  _SFD_DATA_RANGE_CHECK(*c2_b_deltat, 5U);
  c2_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,1);
  c2_hoistedGlobal = *c2_b_yCurrent;
  c2_b_hoistedGlobal = *c2_b_rCurrent;
  c2_c_hoistedGlobal = *c2_b_Kc;
  c2_d_hoistedGlobal = *c2_b_tauI;
  c2_e_hoistedGlobal = *c2_b_deltat;
  c2_yCurrent = c2_hoistedGlobal;
  c2_rCurrent = c2_b_hoistedGlobal;
  c2_Kc = c2_c_hoistedGlobal;
  c2_tauI = c2_d_hoistedGlobal;
  c2_deltat = c2_e_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c2_debug_family_names,
    c2_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c2_nargin, c2_c_sf_marshall, 0U);
  sf_debug_symbol_scope_add_eml(&c2_nargout, c2_c_sf_marshall, 1U);
  sf_debug_symbol_scope_add_eml(&c2_yCurrent, c2_c_sf_marshall, 2U);
  sf_debug_symbol_scope_add_eml(&c2_rCurrent, c2_c_sf_marshall, 3U);
  sf_debug_symbol_scope_add_eml(&c2_Kc, c2_c_sf_marshall, 4U);
  sf_debug_symbol_scope_add_eml(&c2_tauI, c2_c_sf_marshall, 5U);
  sf_debug_symbol_scope_add_eml(&c2_deltat, c2_c_sf_marshall, 6U);
  sf_debug_symbol_scope_add_eml(&c2_uCurrent, c2_c_sf_marshall, 7U);
  sf_debug_symbol_scope_add_eml(&chartInstance->c2_uPast, c2_b_sf_marshall, 8U);
  sf_debug_symbol_scope_add_eml(&chartInstance->c2_yPast, c2_sf_marshall, 9U);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  if (CV_EML_IF(0, 0, !chartInstance->c2_uPast_not_empty)) {
    _SFD_EML_CALL(0,4);
    chartInstance->c2_uPast = 0.0;
    chartInstance->c2_uPast_not_empty = TRUE;
  }

  _SFD_EML_CALL(0,7);
  if (CV_EML_IF(0, 1, !chartInstance->c2_yPast_not_empty)) {
    _SFD_EML_CALL(0,8);
    chartInstance->c2_yPast = 0.0;
    chartInstance->c2_yPast_not_empty = TRUE;
  }

  _SFD_EML_CALL(0,10);
  c2_f_hoistedGlobal = chartInstance->c2_uPast;
  c2_g_hoistedGlobal = chartInstance->c2_yPast;
  c2_a = c2_Kc;
  c2_b = (-c2_yCurrent) + c2_g_hoistedGlobal;
  c2_y = c2_a * c2_b;
  c2_b_a = c2_Kc;
  c2_b_b = c2_deltat;
  c2_b_y = c2_b_a * c2_b_b;
  c2_A = c2_b_y;
  c2_B = c2_tauI;
  c2_x = c2_A;
  c2_c_y = c2_B;
  c2_b_x = c2_x;
  c2_d_y = c2_c_y;
  c2_c_x = c2_b_x;
  c2_e_y = c2_d_y;
  c2_f_y = c2_c_x / c2_e_y;
  c2_c_a = c2_f_y;
  c2_c_b = c2_rCurrent - c2_yCurrent;
  c2_g_y = c2_c_a * c2_c_b;
  c2_uCurrent = (c2_f_hoistedGlobal + c2_y) + c2_g_y;
  _SFD_EML_CALL(0,11);
  chartInstance->c2_uPast = c2_uCurrent;
  _SFD_EML_CALL(0,12);
  chartInstance->c2_yPast = c2_yCurrent;
  _SFD_EML_CALL(0,-12);
  sf_debug_symbol_scope_pop();
  *c2_b_uCurrent = c2_uCurrent;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
  _sfEvent_ = c2_previousEvent;
  sf_debug_check_for_state_inconsistency(_PI_plus_PIMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshall(void *chartInstanceVoid, void *c2_u)
{
  const mxArray *c2_y = NULL;
  real_T c2_b_u;
  const mxArray *c2_b_y = NULL;
  SFc2_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc2_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c2_y = NULL;
  c2_b_u = *((real_T *)c2_u);
  c2_b_y = NULL;
  if (!chartInstance->c2_yPast_not_empty) {
    sf_mex_assign(&c2_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_assign(&c2_y, c2_b_y);
  return c2_y;
}

static const mxArray *c2_b_sf_marshall(void *chartInstanceVoid, void *c2_u)
{
  const mxArray *c2_y = NULL;
  real_T c2_b_u;
  const mxArray *c2_b_y = NULL;
  SFc2_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc2_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c2_y = NULL;
  c2_b_u = *((real_T *)c2_u);
  c2_b_y = NULL;
  if (!chartInstance->c2_uPast_not_empty) {
    sf_mex_assign(&c2_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_assign(&c2_y, c2_b_y);
  return c2_y;
}

static const mxArray *c2_c_sf_marshall(void *chartInstanceVoid, void *c2_u)
{
  const mxArray *c2_y = NULL;
  real_T c2_b_u;
  const mxArray *c2_b_y = NULL;
  SFc2_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc2_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c2_y = NULL;
  c2_b_u = *((real_T *)c2_u);
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c2_y, c2_b_y);
  return c2_y;
}

const mxArray *sf_c2_PI_plus_PI_get_eml_resolved_functions_info(void)
{
  const mxArray *c2_nameCaptureInfo = NULL;
  c2_ResolvedFunctionInfo c2_info[19];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i0;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_info_helper(c2_info);
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 19));
  for (c2_i0 = 0; c2_i0 < 19; c2_i0 = c2_i0 + 1) {
    c2_r0 = &c2_info[c2_i0];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context",
                    "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name",
                    "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c2_i0);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0);
  return c2_nameCaptureInfo;
}

static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[19])
{
  c2_info[0].context = "";
  c2_info[0].name = "uminus";
  c2_info[0].dominantType = "double";
  c2_info[0].resolved = "[B]uminus";
  c2_info[0].fileLength = 0U;
  c2_info[0].fileTime1 = 0U;
  c2_info[0].fileTime2 = 0U;
  c2_info[1].context = "";
  c2_info[1].name = "plus";
  c2_info[1].dominantType = "double";
  c2_info[1].resolved = "[B]plus";
  c2_info[1].fileLength = 0U;
  c2_info[1].fileTime1 = 0U;
  c2_info[1].fileTime2 = 0U;
  c2_info[2].context = "";
  c2_info[2].name = "mtimes";
  c2_info[2].dominantType = "double";
  c2_info[2].resolved = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[2].fileLength = 3425U;
  c2_info[2].fileTime1 = 1250643966U;
  c2_info[2].fileTime2 = 0U;
  c2_info[3].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[3].name = "nargin";
  c2_info[3].dominantType = "";
  c2_info[3].resolved = "[B]nargin";
  c2_info[3].fileLength = 0U;
  c2_info[3].fileTime1 = 0U;
  c2_info[3].fileTime2 = 0U;
  c2_info[4].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[4].name = "gt";
  c2_info[4].dominantType = "double";
  c2_info[4].resolved = "[B]gt";
  c2_info[4].fileLength = 0U;
  c2_info[4].fileTime1 = 0U;
  c2_info[4].fileTime2 = 0U;
  c2_info[5].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[5].name = "isa";
  c2_info[5].dominantType = "double";
  c2_info[5].resolved = "[B]isa";
  c2_info[5].fileLength = 0U;
  c2_info[5].fileTime1 = 0U;
  c2_info[5].fileTime2 = 0U;
  c2_info[6].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[6].name = "isinteger";
  c2_info[6].dominantType = "double";
  c2_info[6].resolved = "[B]isinteger";
  c2_info[6].fileLength = 0U;
  c2_info[6].fileTime1 = 0U;
  c2_info[6].fileTime2 = 0U;
  c2_info[7].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[7].name = "isscalar";
  c2_info[7].dominantType = "double";
  c2_info[7].resolved = "[B]isscalar";
  c2_info[7].fileLength = 0U;
  c2_info[7].fileTime1 = 0U;
  c2_info[7].fileTime2 = 0U;
  c2_info[8].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[8].name = "strcmp";
  c2_info[8].dominantType = "char";
  c2_info[8].resolved = "[B]strcmp";
  c2_info[8].fileLength = 0U;
  c2_info[8].fileTime1 = 0U;
  c2_info[8].fileTime2 = 0U;
  c2_info[9].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[9].name = "size";
  c2_info[9].dominantType = "double";
  c2_info[9].resolved = "[B]size";
  c2_info[9].fileLength = 0U;
  c2_info[9].fileTime1 = 0U;
  c2_info[9].fileTime2 = 0U;
  c2_info[10].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[10].name = "eq";
  c2_info[10].dominantType = "double";
  c2_info[10].resolved = "[B]eq";
  c2_info[10].fileLength = 0U;
  c2_info[10].fileTime1 = 0U;
  c2_info[10].fileTime2 = 0U;
  c2_info[11].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[11].name = "class";
  c2_info[11].dominantType = "double";
  c2_info[11].resolved = "[B]class";
  c2_info[11].fileLength = 0U;
  c2_info[11].fileTime1 = 0U;
  c2_info[11].fileTime2 = 0U;
  c2_info[12].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[12].name = "not";
  c2_info[12].dominantType = "logical";
  c2_info[12].resolved = "[B]not";
  c2_info[12].fileLength = 0U;
  c2_info[12].fileTime1 = 0U;
  c2_info[12].fileTime2 = 0U;
  c2_info[13].context = "";
  c2_info[13].name = "mrdivide";
  c2_info[13].dominantType = "double";
  c2_info[13].resolved =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c2_info[13].fileLength = 800U;
  c2_info[13].fileTime1 = 1238401890U;
  c2_info[13].fileTime2 = 0U;
  c2_info[14].context =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c2_info[14].name = "ge";
  c2_info[14].dominantType = "double";
  c2_info[14].resolved = "[B]ge";
  c2_info[14].fileLength = 0U;
  c2_info[14].fileTime1 = 0U;
  c2_info[14].fileTime2 = 0U;
  c2_info[15].context =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c2_info[15].name = "rdivide";
  c2_info[15].dominantType = "double";
  c2_info[15].resolved =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[15].fileLength = 403U;
  c2_info[15].fileTime1 = 1244706752U;
  c2_info[15].fileTime2 = 0U;
  c2_info[16].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[16].name = "eml_div";
  c2_info[16].dominantType = "double";
  c2_info[16].resolved =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c2_info[16].fileLength = 4269U;
  c2_info[16].fileTime1 = 1228057826U;
  c2_info[16].fileTime2 = 0U;
  c2_info[17].context =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m/eml_fldiv";
  c2_info[17].name = "isreal";
  c2_info[17].dominantType = "double";
  c2_info[17].resolved = "[B]isreal";
  c2_info[17].fileLength = 0U;
  c2_info[17].fileTime1 = 0U;
  c2_info[17].fileTime2 = 0U;
  c2_info[18].context = "";
  c2_info[18].name = "minus";
  c2_info[18].dominantType = "double";
  c2_info[18].resolved = "[B]minus";
  c2_info[18].fileLength = 0U;
  c2_info[18].fileTime1 = 0U;
  c2_info[18].fileTime2 = 0U;
}

static const mxArray *c2_d_sf_marshall(void *chartInstanceVoid, void *c2_u)
{
  const mxArray *c2_y = NULL;
  boolean_T c2_b_u;
  const mxArray *c2_b_y = NULL;
  SFc2_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc2_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c2_y = NULL;
  c2_b_u = *((boolean_T *)c2_u);
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_b_u, 11, 0U, 0U, 0U, 0));
  sf_mex_assign(&c2_y, c2_b_y);
  return c2_y;
}

static real_T c2_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c2_uCurrent, const char_T *c2_name)
{
  real_T c2_y;
  real_T c2_d0;
  sf_mex_import(c2_name, sf_mex_dup(c2_uCurrent), &c2_d0, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d0;
  sf_mex_destroy(&c2_uCurrent);
  return c2_y;
}

static real_T c2_b_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c2_b_uPast, const char_T *c2_name)
{
  real_T c2_y;
  real_T c2_d1;
  if (mxIsEmpty(c2_b_uPast)) {
    chartInstance->c2_uPast_not_empty = FALSE;
  } else {
    chartInstance->c2_uPast_not_empty = TRUE;
    sf_mex_import(c2_name, sf_mex_dup(c2_b_uPast), &c2_d1, 1, 0, 0U, 0, 0U, 0);
    c2_y = c2_d1;
  }

  sf_mex_destroy(&c2_b_uPast);
  return c2_y;
}

static real_T c2_c_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c2_b_yPast, const char_T *c2_name)
{
  real_T c2_y;
  real_T c2_d2;
  if (mxIsEmpty(c2_b_yPast)) {
    chartInstance->c2_yPast_not_empty = FALSE;
  } else {
    chartInstance->c2_yPast_not_empty = TRUE;
    sf_mex_import(c2_name, sf_mex_dup(c2_b_yPast), &c2_d2, 1, 0, 0U, 0, 0U, 0);
    c2_y = c2_d2;
  }

  sf_mex_destroy(&c2_b_yPast);
  return c2_y;
}

static uint8_T c2_d_emlrt_marshallIn(SFc2_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c2_b_is_active_c2_PI_plus_PI,
  const char_T *c2_name)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_name, sf_mex_dup(c2_b_is_active_c2_PI_plus_PI), &c2_u0, 1, 3,
                0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_b_is_active_c2_PI_plus_PI);
  return c2_y;
}

static void init_dsm_address_info(SFc2_PI_plus_PIInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c2_PI_plus_PI_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2241289692U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3875098168U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2669189425U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(138845238U);
}

mxArray *sf_c2_PI_plus_PI_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3868094635U);
    pr[1] = (double)(3608238795U);
    pr[2] = (double)(1455756968U);
    pr[3] = (double)(118487521U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c2_PI_plus_PI(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[5],T\"uCurrent\",},{M[4],M[0],T\"uPast\",S'l','i','p'{{M1x2[69 74],M[0],}}},{M[4],M[0],T\"yPast\",S'l','i','p'{{M1x2[121 126],M[0],}}},{M[8],M[0],T\"is_active_c2_PI_plus_PI\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_PI_plus_PI_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_PI_plus_PIInstanceStruct *chartInstance;
    chartInstance = (SFc2_PI_plus_PIInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_PI_plus_PIMachineNumber_,
           2,
           1,
           1,
           6,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_PI_plus_PIMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_PI_plus_PIMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_PI_plus_PIMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "yCurrent",0,(MexFcnForType)c2_c_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "uCurrent",0,(MexFcnForType)c2_c_sf_marshall);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "rCurrent",0,(MexFcnForType)c2_c_sf_marshall);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"Kc",0,
                              (MexFcnForType)c2_c_sf_marshall);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"tauI",0,
                              (MexFcnForType)c2_c_sf_marshall);
          _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"deltat",
                              0,(MexFcnForType)c2_c_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,271);
        _SFD_CV_INIT_EML_IF(0,0,75,92,-1,109);
        _SFD_CV_INIT_EML_IF(0,1,127,144,-1,161);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c2_yCurrent;
          real_T *c2_uCurrent;
          real_T *c2_rCurrent;
          real_T *c2_Kc;
          real_T *c2_tauI;
          real_T *c2_deltat;
          c2_deltat = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c2_tauI = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c2_Kc = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c2_rCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c2_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c2_yCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c2_yCurrent);
          _SFD_SET_DATA_VALUE_PTR(1U, c2_uCurrent);
          _SFD_SET_DATA_VALUE_PTR(2U, c2_rCurrent);
          _SFD_SET_DATA_VALUE_PTR(3U, c2_Kc);
          _SFD_SET_DATA_VALUE_PTR(4U, c2_tauI);
          _SFD_SET_DATA_VALUE_PTR(5U, c2_deltat);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_PI_plus_PIMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c2_PI_plus_PI(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*)
    chartInstanceVar);
  initialize_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c2_PI_plus_PI(void *chartInstanceVar)
{
  enable_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c2_PI_plus_PI(void *chartInstanceVar)
{
  disable_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c2_PI_plus_PI(void *chartInstanceVar)
{
  sf_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static mxArray* sf_internal_get_sim_state_c2_PI_plus_PI(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_PI_plus_PI
    ((SFc2_PI_plus_PIInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = sf_get_sim_state_info_c2_PI_plus_PI();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

static void sf_internal_set_sim_state_c2_PI_plus_PI(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_PI_plus_PI();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static mxArray* sf_opaque_get_sim_state_c2_PI_plus_PI(SimStruct* S)
{
  return sf_internal_get_sim_state_c2_PI_plus_PI(S);
}

static void sf_opaque_set_sim_state_c2_PI_plus_PI(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c2_PI_plus_PI(S, st);
}

static void sf_opaque_terminate_c2_PI_plus_PI(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_PI_plus_PI(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_PI_plus_PI((SFc2_PI_plus_PIInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_PI_plus_PI(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("PI_plus_PI","PI_plus_PI",2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("PI_plus_PI","PI_plus_PI",2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("PI_plus_PI","PI_plus_PI",
      2,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"PI_plus_PI","PI_plus_PI",2,5);
      sf_mark_chart_reusable_outputs(S,"PI_plus_PI","PI_plus_PI",2,1);
    }

    sf_set_rtw_dwork_info(S,"PI_plus_PI","PI_plus_PI",2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3331780686U));
  ssSetChecksum1(S,(456795619U));
  ssSetChecksum2(S,(3293262261U));
  ssSetChecksum3(S,(3889159728U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c2_PI_plus_PI(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "PI_plus_PI", "PI_plus_PI",2);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_PI_plus_PI(SimStruct *S)
{
  SFc2_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc2_PI_plus_PIInstanceStruct *)malloc(sizeof
    (SFc2_PI_plus_PIInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc2_PI_plus_PIInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c2_PI_plus_PI;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c2_PI_plus_PI;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c2_PI_plus_PI;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c2_PI_plus_PI;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c2_PI_plus_PI;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c2_PI_plus_PI;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c2_PI_plus_PI;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c2_PI_plus_PI;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_PI_plus_PI;
  chartInstance->chartInfo.mdlStart = mdlStart_c2_PI_plus_PI;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c2_PI_plus_PI;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info(chartInstance);
  }

  chart_debug_initialization(S,1);
}

void c2_PI_plus_PI_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_PI_plus_PI(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_PI_plus_PI(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_PI_plus_PI(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_PI_plus_PI_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
