/* Include files */

#include "blascompat32.h"
#include "PI_plus_PI_sfun.h"
#include "c1_PI_plus_PI.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "PI_plus_PI_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char *c1_debug_family_names[12] = { "nargin", "nargout", "yCurrent",
  "rCurrent", "f", "Kc", "tauI", "deltat", "uCurrent", "uPast", "yPast", "fPast"
};

/* Function Declarations */
static void initialize_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance);
static void initialize_params_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance);
static void enable_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance);
static void disable_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance);
static void c1_update_debugger_state_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *
  chartInstance);
static void set_sim_state_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c1_st);
static void finalize_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance);
static void sf_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshall(void *chartInstanceVoid, void *c1_u);
static const mxArray *c1_b_sf_marshall(void *chartInstanceVoid, void *c1_u);
static const mxArray *c1_c_sf_marshall(void *chartInstanceVoid, void *c1_u);
static const mxArray *c1_d_sf_marshall(void *chartInstanceVoid, void *c1_u);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[19]);
static const mxArray *c1_e_sf_marshall(void *chartInstanceVoid, void *c1_u);
static real_T c1_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_uCurrent, const char_T *c1_name);
static real_T c1_b_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_b_fPast, const char_T *c1_name);
static real_T c1_c_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_b_uPast, const char_T *c1_name);
static real_T c1_d_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_b_yPast, const char_T *c1_name);
static uint8_T c1_e_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c1_b_is_active_c1_PI_plus_PI, const char_T
  *c1_name);
static void init_dsm_address_info(SFc1_PI_plus_PIInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c1_uPast_not_empty = FALSE;
  chartInstance->c1_yPast_not_empty = FALSE;
  chartInstance->c1_fPast_not_empty = FALSE;
  chartInstance->c1_is_active_c1_PI_plus_PI = 0U;
}

static void initialize_params_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance)
{
}

static void enable_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c1_update_debugger_state_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *
  chartInstance)
{
  const mxArray *c1_st = NULL;
  const mxArray *c1_y = NULL;
  real_T c1_hoistedGlobal;
  real_T c1_u;
  const mxArray *c1_b_y = NULL;
  real_T c1_b_hoistedGlobal;
  real_T c1_b_u;
  const mxArray *c1_c_y = NULL;
  real_T c1_c_hoistedGlobal;
  real_T c1_c_u;
  const mxArray *c1_d_y = NULL;
  real_T c1_d_hoistedGlobal;
  real_T c1_d_u;
  const mxArray *c1_e_y = NULL;
  uint8_T c1_e_hoistedGlobal;
  uint8_T c1_e_u;
  const mxArray *c1_f_y = NULL;
  real_T *c1_uCurrent;
  c1_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(5));
  c1_hoistedGlobal = *c1_uCurrent;
  c1_u = c1_hoistedGlobal;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 0, c1_b_y);
  c1_b_hoistedGlobal = chartInstance->c1_fPast;
  c1_b_u = c1_b_hoistedGlobal;
  c1_c_y = NULL;
  if (!chartInstance->c1_fPast_not_empty) {
    sf_mex_assign(&c1_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_setcell(c1_y, 1, c1_c_y);
  c1_c_hoistedGlobal = chartInstance->c1_uPast;
  c1_c_u = c1_c_hoistedGlobal;
  c1_d_y = NULL;
  if (!chartInstance->c1_uPast_not_empty) {
    sf_mex_assign(&c1_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c1_d_y, sf_mex_create("y", &c1_c_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_setcell(c1_y, 2, c1_d_y);
  c1_d_hoistedGlobal = chartInstance->c1_yPast;
  c1_d_u = c1_d_hoistedGlobal;
  c1_e_y = NULL;
  if (!chartInstance->c1_yPast_not_empty) {
    sf_mex_assign(&c1_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c1_e_y, sf_mex_create("y", &c1_d_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_setcell(c1_y, 3, c1_e_y);
  c1_e_hoistedGlobal = chartInstance->c1_is_active_c1_PI_plus_PI;
  c1_e_u = c1_e_hoistedGlobal;
  c1_f_y = NULL;
  sf_mex_assign(&c1_f_y, sf_mex_create("y", &c1_e_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 4, c1_f_y);
  sf_mex_assign(&c1_st, c1_y);
  return c1_st;
}

static void set_sim_state_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c1_st)
{
  const mxArray *c1_u;
  real_T *c1_uCurrent;
  c1_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c1_doneDoubleBufferReInit = TRUE;
  c1_u = sf_mex_dup(c1_st);
  *c1_uCurrent = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c1_u, 0)), "uCurrent");
  chartInstance->c1_fPast = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c1_u, 1)), "fPast");
  chartInstance->c1_uPast = c1_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c1_u, 2)), "uPast");
  chartInstance->c1_yPast = c1_d_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c1_u, 3)), "yPast");
  chartInstance->c1_is_active_c1_PI_plus_PI = c1_e_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 4)),
     "is_active_c1_PI_plus_PI");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_PI_plus_PI(chartInstance);
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance)
{
}

static void sf_c1_PI_plus_PI(SFc1_PI_plus_PIInstanceStruct *chartInstance)
{
  int32_T c1_previousEvent;
  real_T c1_hoistedGlobal;
  real_T c1_b_hoistedGlobal;
  real_T c1_c_hoistedGlobal;
  real_T c1_d_hoistedGlobal;
  real_T c1_e_hoistedGlobal;
  real_T c1_f_hoistedGlobal;
  real_T c1_yCurrent;
  real_T c1_rCurrent;
  real_T c1_f;
  real_T c1_Kc;
  real_T c1_tauI;
  real_T c1_deltat;
  uint32_T c1_debug_family_var_map[12];
  real_T c1_nargin = 6.0;
  real_T c1_nargout = 1.0;
  real_T c1_uCurrent;
  real_T c1_g_hoistedGlobal;
  real_T c1_h_hoistedGlobal;
  real_T c1_a;
  real_T c1_b;
  real_T c1_y;
  real_T c1_b_a;
  real_T c1_b_b;
  real_T c1_b_y;
  real_T c1_A;
  real_T c1_B;
  real_T c1_x;
  real_T c1_c_y;
  real_T c1_b_x;
  real_T c1_d_y;
  real_T c1_c_x;
  real_T c1_e_y;
  real_T c1_f_y;
  real_T c1_c_a;
  real_T c1_c_b;
  real_T c1_g_y;
  real_T *c1_b_yCurrent;
  real_T *c1_b_uCurrent;
  real_T *c1_b_rCurrent;
  real_T *c1_b_f;
  real_T *c1_b_Kc;
  real_T *c1_b_tauI;
  real_T *c1_b_deltat;
  c1_b_deltat = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c1_b_tauI = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c1_b_Kc = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c1_b_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c1_b_rCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c1_b_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_b_yCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  _SFD_DATA_RANGE_CHECK(*c1_b_yCurrent, 0U);
  _SFD_DATA_RANGE_CHECK(*c1_b_uCurrent, 1U);
  _SFD_DATA_RANGE_CHECK(*c1_b_rCurrent, 2U);
  _SFD_DATA_RANGE_CHECK(*c1_b_f, 3U);
  _SFD_DATA_RANGE_CHECK(*c1_b_Kc, 4U);
  _SFD_DATA_RANGE_CHECK(*c1_b_tauI, 5U);
  _SFD_DATA_RANGE_CHECK(*c1_b_deltat, 6U);
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  c1_hoistedGlobal = *c1_b_yCurrent;
  c1_b_hoistedGlobal = *c1_b_rCurrent;
  c1_c_hoistedGlobal = *c1_b_f;
  c1_d_hoistedGlobal = *c1_b_Kc;
  c1_e_hoistedGlobal = *c1_b_tauI;
  c1_f_hoistedGlobal = *c1_b_deltat;
  c1_yCurrent = c1_hoistedGlobal;
  c1_rCurrent = c1_b_hoistedGlobal;
  c1_f = c1_c_hoistedGlobal;
  c1_Kc = c1_d_hoistedGlobal;
  c1_tauI = c1_e_hoistedGlobal;
  c1_deltat = c1_f_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 12U, 12U, c1_debug_family_names,
    c1_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c1_nargin, c1_d_sf_marshall, 0U);
  sf_debug_symbol_scope_add_eml(&c1_nargout, c1_d_sf_marshall, 1U);
  sf_debug_symbol_scope_add_eml(&c1_yCurrent, c1_d_sf_marshall, 2U);
  sf_debug_symbol_scope_add_eml(&c1_rCurrent, c1_d_sf_marshall, 3U);
  sf_debug_symbol_scope_add_eml(&c1_f, c1_d_sf_marshall, 4U);
  sf_debug_symbol_scope_add_eml(&c1_Kc, c1_d_sf_marshall, 5U);
  sf_debug_symbol_scope_add_eml(&c1_tauI, c1_d_sf_marshall, 6U);
  sf_debug_symbol_scope_add_eml(&c1_deltat, c1_d_sf_marshall, 7U);
  sf_debug_symbol_scope_add_eml(&c1_uCurrent, c1_d_sf_marshall, 8U);
  sf_debug_symbol_scope_add_eml(&chartInstance->c1_uPast, c1_c_sf_marshall, 9U);
  sf_debug_symbol_scope_add_eml(&chartInstance->c1_yPast, c1_b_sf_marshall, 10U);
  sf_debug_symbol_scope_add_eml(&chartInstance->c1_fPast, c1_sf_marshall, 11U);
  CV_EML_FCN(0, 0);

  /* f is the feedforward variable */
  _SFD_EML_CALL(0,4);
  if (CV_EML_IF(0, 0, !chartInstance->c1_uPast_not_empty)) {
    _SFD_EML_CALL(0,5);
    chartInstance->c1_uPast = 0.0;
    chartInstance->c1_uPast_not_empty = TRUE;
  }

  _SFD_EML_CALL(0,8);
  if (CV_EML_IF(0, 1, !chartInstance->c1_yPast_not_empty)) {
    _SFD_EML_CALL(0,9);
    chartInstance->c1_yPast = 0.0;
    chartInstance->c1_yPast_not_empty = TRUE;
  }

  _SFD_EML_CALL(0,12);
  if (CV_EML_IF(0, 2, !chartInstance->c1_fPast_not_empty)) {
    _SFD_EML_CALL(0,13);
    chartInstance->c1_fPast = 0.0;
    chartInstance->c1_fPast_not_empty = TRUE;
  }

  _SFD_EML_CALL(0,15);
  c1_g_hoistedGlobal = chartInstance->c1_uPast;
  c1_h_hoistedGlobal = chartInstance->c1_yPast;
  c1_a = c1_Kc;
  c1_b = (-c1_yCurrent) + c1_h_hoistedGlobal;
  c1_y = c1_a * c1_b;
  c1_b_a = c1_Kc;
  c1_b_b = c1_deltat;
  c1_b_y = c1_b_a * c1_b_b;
  c1_A = c1_b_y;
  c1_B = c1_tauI;
  c1_x = c1_A;
  c1_c_y = c1_B;
  c1_b_x = c1_x;
  c1_d_y = c1_c_y;
  c1_c_x = c1_b_x;
  c1_e_y = c1_d_y;
  c1_f_y = c1_c_x / c1_e_y;
  c1_c_a = c1_f_y;
  c1_c_b = c1_rCurrent - c1_yCurrent;
  c1_g_y = c1_c_a * c1_c_b;
  c1_uCurrent = (((c1_g_hoistedGlobal + c1_y) + c1_g_y) + c1_f) -
    chartInstance->c1_fPast;
  _SFD_EML_CALL(0,16);
  chartInstance->c1_uPast = c1_uCurrent;
  _SFD_EML_CALL(0,17);
  chartInstance->c1_yPast = c1_yCurrent;
  _SFD_EML_CALL(0,18);
  chartInstance->c1_fPast = c1_f;
  _SFD_EML_CALL(0,-18);
  sf_debug_symbol_scope_pop();
  *c1_b_uCurrent = c1_uCurrent;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_PI_plus_PIMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static const mxArray *c1_sf_marshall(void *chartInstanceVoid, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  SFc1_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc1_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  if (!chartInstance->c1_fPast_not_empty) {
    sf_mex_assign(&c1_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_b_sf_marshall(void *chartInstanceVoid, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  SFc1_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc1_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  if (!chartInstance->c1_yPast_not_empty) {
    sf_mex_assign(&c1_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_c_sf_marshall(void *chartInstanceVoid, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  SFc1_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc1_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  if (!chartInstance->c1_uPast_not_empty) {
    sf_mex_assign(&c1_b_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0));
  } else {
    sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  }

  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_d_sf_marshall(void *chartInstanceVoid, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  SFc1_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc1_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

const mxArray *sf_c1_PI_plus_PI_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_ResolvedFunctionInfo c1_info[19];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i0;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 19));
  for (c1_i0 = 0; c1_i0 < 19; c1_i0 = c1_i0 + 1) {
    c1_r0 = &c1_info[c1_i0];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context",
                    "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name",
                    "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c1_i0);
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[19])
{
  c1_info[0].context = "";
  c1_info[0].name = "uminus";
  c1_info[0].dominantType = "double";
  c1_info[0].resolved = "[B]uminus";
  c1_info[0].fileLength = 0U;
  c1_info[0].fileTime1 = 0U;
  c1_info[0].fileTime2 = 0U;
  c1_info[1].context = "";
  c1_info[1].name = "plus";
  c1_info[1].dominantType = "double";
  c1_info[1].resolved = "[B]plus";
  c1_info[1].fileLength = 0U;
  c1_info[1].fileTime1 = 0U;
  c1_info[1].fileTime2 = 0U;
  c1_info[2].context = "";
  c1_info[2].name = "mtimes";
  c1_info[2].dominantType = "double";
  c1_info[2].resolved = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[2].fileLength = 3425U;
  c1_info[2].fileTime1 = 1250643966U;
  c1_info[2].fileTime2 = 0U;
  c1_info[3].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[3].name = "nargin";
  c1_info[3].dominantType = "";
  c1_info[3].resolved = "[B]nargin";
  c1_info[3].fileLength = 0U;
  c1_info[3].fileTime1 = 0U;
  c1_info[3].fileTime2 = 0U;
  c1_info[4].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[4].name = "gt";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved = "[B]gt";
  c1_info[4].fileLength = 0U;
  c1_info[4].fileTime1 = 0U;
  c1_info[4].fileTime2 = 0U;
  c1_info[5].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[5].name = "isa";
  c1_info[5].dominantType = "double";
  c1_info[5].resolved = "[B]isa";
  c1_info[5].fileLength = 0U;
  c1_info[5].fileTime1 = 0U;
  c1_info[5].fileTime2 = 0U;
  c1_info[6].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[6].name = "isinteger";
  c1_info[6].dominantType = "double";
  c1_info[6].resolved = "[B]isinteger";
  c1_info[6].fileLength = 0U;
  c1_info[6].fileTime1 = 0U;
  c1_info[6].fileTime2 = 0U;
  c1_info[7].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[7].name = "isscalar";
  c1_info[7].dominantType = "double";
  c1_info[7].resolved = "[B]isscalar";
  c1_info[7].fileLength = 0U;
  c1_info[7].fileTime1 = 0U;
  c1_info[7].fileTime2 = 0U;
  c1_info[8].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[8].name = "strcmp";
  c1_info[8].dominantType = "char";
  c1_info[8].resolved = "[B]strcmp";
  c1_info[8].fileLength = 0U;
  c1_info[8].fileTime1 = 0U;
  c1_info[8].fileTime2 = 0U;
  c1_info[9].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[9].name = "size";
  c1_info[9].dominantType = "double";
  c1_info[9].resolved = "[B]size";
  c1_info[9].fileLength = 0U;
  c1_info[9].fileTime1 = 0U;
  c1_info[9].fileTime2 = 0U;
  c1_info[10].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[10].name = "eq";
  c1_info[10].dominantType = "double";
  c1_info[10].resolved = "[B]eq";
  c1_info[10].fileLength = 0U;
  c1_info[10].fileTime1 = 0U;
  c1_info[10].fileTime2 = 0U;
  c1_info[11].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[11].name = "class";
  c1_info[11].dominantType = "double";
  c1_info[11].resolved = "[B]class";
  c1_info[11].fileLength = 0U;
  c1_info[11].fileTime1 = 0U;
  c1_info[11].fileTime2 = 0U;
  c1_info[12].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[12].name = "not";
  c1_info[12].dominantType = "logical";
  c1_info[12].resolved = "[B]not";
  c1_info[12].fileLength = 0U;
  c1_info[12].fileTime1 = 0U;
  c1_info[12].fileTime2 = 0U;
  c1_info[13].context = "";
  c1_info[13].name = "mrdivide";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[13].fileLength = 800U;
  c1_info[13].fileTime1 = 1238401890U;
  c1_info[13].fileTime2 = 0U;
  c1_info[14].context =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[14].name = "ge";
  c1_info[14].dominantType = "double";
  c1_info[14].resolved = "[B]ge";
  c1_info[14].fileLength = 0U;
  c1_info[14].fileTime1 = 0U;
  c1_info[14].fileTime2 = 0U;
  c1_info[15].context =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c1_info[15].name = "rdivide";
  c1_info[15].dominantType = "double";
  c1_info[15].resolved =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[15].fileLength = 403U;
  c1_info[15].fileTime1 = 1244706752U;
  c1_info[15].fileTime2 = 0U;
  c1_info[16].context = "[ILX]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[16].name = "eml_div";
  c1_info[16].dominantType = "double";
  c1_info[16].resolved =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c1_info[16].fileLength = 4269U;
  c1_info[16].fileTime1 = 1228057826U;
  c1_info[16].fileTime2 = 0U;
  c1_info[17].context =
    "[ILX]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m/eml_fldiv";
  c1_info[17].name = "isreal";
  c1_info[17].dominantType = "double";
  c1_info[17].resolved = "[B]isreal";
  c1_info[17].fileLength = 0U;
  c1_info[17].fileTime1 = 0U;
  c1_info[17].fileTime2 = 0U;
  c1_info[18].context = "";
  c1_info[18].name = "minus";
  c1_info[18].dominantType = "double";
  c1_info[18].resolved = "[B]minus";
  c1_info[18].fileLength = 0U;
  c1_info[18].fileTime1 = 0U;
  c1_info[18].fileTime2 = 0U;
}

static const mxArray *c1_e_sf_marshall(void *chartInstanceVoid, void *c1_u)
{
  const mxArray *c1_y = NULL;
  boolean_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  SFc1_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc1_PI_plus_PIInstanceStruct *)chartInstanceVoid;
  c1_y = NULL;
  c1_b_u = *((boolean_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 11, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static real_T c1_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_uCurrent, const char_T *c1_name)
{
  real_T c1_y;
  real_T c1_d0;
  sf_mex_import(c1_name, sf_mex_dup(c1_uCurrent), &c1_d0, 1, 0, 0U, 0, 0U, 0);
  c1_y = c1_d0;
  sf_mex_destroy(&c1_uCurrent);
  return c1_y;
}

static real_T c1_b_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_b_fPast, const char_T *c1_name)
{
  real_T c1_y;
  real_T c1_d1;
  if (mxIsEmpty(c1_b_fPast)) {
    chartInstance->c1_fPast_not_empty = FALSE;
  } else {
    chartInstance->c1_fPast_not_empty = TRUE;
    sf_mex_import(c1_name, sf_mex_dup(c1_b_fPast), &c1_d1, 1, 0, 0U, 0, 0U, 0);
    c1_y = c1_d1;
  }

  sf_mex_destroy(&c1_b_fPast);
  return c1_y;
}

static real_T c1_c_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_b_uPast, const char_T *c1_name)
{
  real_T c1_y;
  real_T c1_d2;
  if (mxIsEmpty(c1_b_uPast)) {
    chartInstance->c1_uPast_not_empty = FALSE;
  } else {
    chartInstance->c1_uPast_not_empty = TRUE;
    sf_mex_import(c1_name, sf_mex_dup(c1_b_uPast), &c1_d2, 1, 0, 0U, 0, 0U, 0);
    c1_y = c1_d2;
  }

  sf_mex_destroy(&c1_b_uPast);
  return c1_y;
}

static real_T c1_d_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct *chartInstance,
  const mxArray *c1_b_yPast, const char_T *c1_name)
{
  real_T c1_y;
  real_T c1_d3;
  if (mxIsEmpty(c1_b_yPast)) {
    chartInstance->c1_yPast_not_empty = FALSE;
  } else {
    chartInstance->c1_yPast_not_empty = TRUE;
    sf_mex_import(c1_name, sf_mex_dup(c1_b_yPast), &c1_d3, 1, 0, 0U, 0, 0U, 0);
    c1_y = c1_d3;
  }

  sf_mex_destroy(&c1_b_yPast);
  return c1_y;
}

static uint8_T c1_e_emlrt_marshallIn(SFc1_PI_plus_PIInstanceStruct
  *chartInstance, const mxArray *c1_b_is_active_c1_PI_plus_PI,
  const char_T *c1_name)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_name, sf_mex_dup(c1_b_is_active_c1_PI_plus_PI), &c1_u0, 1, 3,
                0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_b_is_active_c1_PI_plus_PI);
  return c1_y;
}

static void init_dsm_address_info(SFc1_PI_plus_PIInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c1_PI_plus_PI_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3862053742U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3124002340U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1106071738U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2558731922U);
}

mxArray *sf_c1_PI_plus_PI_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2460017464U);
    pr[1] = (double)(3885432692U);
    pr[2] = (double)(558275103U);
    pr[3] = (double)(3888013484U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c1_PI_plus_PI(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[5],T\"uCurrent\",},{M[4],M[0],T\"fPast\",S'l','i','p'{{M1x2[207 212],M[0],}}},{M[4],M[0],T\"uPast\",S'l','i','p'{{M1x2[103 108],M[0],}}},{M[4],M[0],T\"yPast\",S'l','i','p'{{M1x2[155 160],M[0],}}},{M[8],M[0],T\"is_active_c1_PI_plus_PI\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_PI_plus_PI_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc1_PI_plus_PIInstanceStruct *chartInstance;
    chartInstance = (SFc1_PI_plus_PIInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_PI_plus_PIMachineNumber_,
           1,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_PI_plus_PIMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_PI_plus_PIMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_PI_plus_PIMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "yCurrent",0,(MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "uCurrent",0,(MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "rCurrent",0,(MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"f",0,
                              (MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"Kc",0,
                              (MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"tauI",0,
                              (MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"deltat",
                              0,(MexFcnForType)c1_d_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,3,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,375);
        _SFD_CV_INIT_EML_IF(0,0,109,126,-1,143);
        _SFD_CV_INIT_EML_IF(0,1,161,178,-1,195);
        _SFD_CV_INIT_EML_IF(0,2,213,230,-1,247);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c1_yCurrent;
          real_T *c1_uCurrent;
          real_T *c1_rCurrent;
          real_T *c1_f;
          real_T *c1_Kc;
          real_T *c1_tauI;
          real_T *c1_deltat;
          c1_deltat = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c1_tauI = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c1_Kc = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c1_f = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c1_rCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c1_uCurrent = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c1_yCurrent = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_yCurrent);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_uCurrent);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_rCurrent);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_f);
          _SFD_SET_DATA_VALUE_PTR(4U, c1_Kc);
          _SFD_SET_DATA_VALUE_PTR(5U, c1_tauI);
          _SFD_SET_DATA_VALUE_PTR(6U, c1_deltat);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_PI_plus_PIMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c1_PI_plus_PI(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*)
    chartInstanceVar);
  initialize_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c1_PI_plus_PI(void *chartInstanceVar)
{
  enable_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c1_PI_plus_PI(void *chartInstanceVar)
{
  disable_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c1_PI_plus_PI(void *chartInstanceVar)
{
  sf_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar);
}

static mxArray* sf_internal_get_sim_state_c1_PI_plus_PI(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c1_PI_plus_PI
    ((SFc1_PI_plus_PIInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = sf_get_sim_state_info_c1_PI_plus_PI();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

static void sf_internal_set_sim_state_c1_PI_plus_PI(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_PI_plus_PI();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static mxArray* sf_opaque_get_sim_state_c1_PI_plus_PI(SimStruct* S)
{
  return sf_internal_get_sim_state_c1_PI_plus_PI(S);
}

static void sf_opaque_set_sim_state_c1_PI_plus_PI(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c1_PI_plus_PI(S, st);
}

static void sf_opaque_terminate_c1_PI_plus_PI(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_PI_plus_PI(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_PI_plus_PI((SFc1_PI_plus_PIInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c1_PI_plus_PI(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("PI_plus_PI","PI_plus_PI",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("PI_plus_PI","PI_plus_PI",1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("PI_plus_PI","PI_plus_PI",
      1,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"PI_plus_PI","PI_plus_PI",1,6);
      sf_mark_chart_reusable_outputs(S,"PI_plus_PI","PI_plus_PI",1,1);
    }

    sf_set_rtw_dwork_info(S,"PI_plus_PI","PI_plus_PI",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2539520489U));
  ssSetChecksum1(S,(1029701203U));
  ssSetChecksum2(S,(3845377286U));
  ssSetChecksum3(S,(1038547587U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_PI_plus_PI(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "PI_plus_PI", "PI_plus_PI",1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_PI_plus_PI(SimStruct *S)
{
  SFc1_PI_plus_PIInstanceStruct *chartInstance;
  chartInstance = (SFc1_PI_plus_PIInstanceStruct *)malloc(sizeof
    (SFc1_PI_plus_PIInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc1_PI_plus_PIInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c1_PI_plus_PI;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c1_PI_plus_PI;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c1_PI_plus_PI;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c1_PI_plus_PI;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c1_PI_plus_PI;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c1_PI_plus_PI;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c1_PI_plus_PI;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c1_PI_plus_PI;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c1_PI_plus_PI;
  chartInstance->chartInfo.mdlStart = mdlStart_c1_PI_plus_PI;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_PI_plus_PI;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info(chartInstance);
  }

  chart_debug_initialization(S,1);
}

void c1_PI_plus_PI_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_PI_plus_PI(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_PI_plus_PI(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_PI_plus_PI(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_PI_plus_PI_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
