#ifndef __c1_PI_plus_PI_h__
#define __c1_PI_plus_PI_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char *context;
  const char *name;
  const char *dominantType;
  const char *resolved;
  uint32_T fileLength;
  uint32_T fileTime1;
  uint32_T fileTime2;
} c1_ResolvedFunctionInfo;

typedef struct {
  real_T c1_fPast;
  real_T c1_uPast;
  real_T c1_yPast;
  SimStruct *S;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c1_doneDoubleBufferReInit;
  boolean_T c1_fPast_not_empty;
  boolean_T c1_isStable;
  boolean_T c1_uPast_not_empty;
  boolean_T c1_yPast_not_empty;
  uint8_T c1_is_active_c1_PI_plus_PI;
  ChartInfoStruct chartInfo;
} SFc1_PI_plus_PIInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c1_PI_plus_PI_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c1_PI_plus_PI_get_check_sum(mxArray *plhs[]);
extern void c1_PI_plus_PI_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
